/***********************************************************************
// adler32 checksum Mark Adler <madler@alumni.caltech.edu>
// http://quest.jpl.nasa.gov/zlib
************************************************************************/

#include "stdafx.h"
#include "types.h"

#define AADD1(buf,i)  {s1 += buf[i]; s2 += s1;}
#define AADD2(buf,i)  AADD1(buf,i); AADD1(buf,i+1);
#define AADD4(buf,i)  AADD2(buf,i); AADD2(buf,i+2);
#define AADD8(buf,i)  AADD4(buf,i); AADD4(buf,i+4);
#define AADD16(buf,i) { AADD8(buf,i); AADD8(buf,i+8) };

DWORD adler32(DWORD adler, const BYTE *buf, unsigned len) {

	DWORD s1 = adler & 0xffff;
	DWORD s2 = (adler >> 16) & 0xffff;
	int k;

	while (len > 0) {
		k = len < 5552 ? (int) len : 5552;
		len -= k;
        for (; k >= 16; k -= 16, buf += 16) AADD16(buf,0);
		for (; k > 0; k--, s1 += *buf++, s2 += s1);
		s1 %= 65521u;
		s2 %= 65521u;
	}
	return (s2 << 16) | s1;
}
