// ***************************************************************
// SAMPLE.CPP       CLIB I/O datafile interceptor             v2.0
//
// (C) Copyright 1998-2000 7Gods demo group http://7gods.sk
//
// sample file
// ***************************************************************
#include "stdafx.h"
// be sure to include DOLZIO.H in every source module that uses files from datafiles
// STDIO.H *must* be included before DOLZIO.H
#include "dolzio.h"

// ***************************************************************
// This exaple shows how simple reads and writes can be done
int main(int argc, char* argv[]) {

	char buf[100];		// our temporary buffer
	int x;

	if (argc != 3) {
		puts("\nUsage: SAMPLE.EXE <datafile> <file>");
		puts("uncompresses <file> into file \"outfile\"\n");
		return 0;
	}

	if (open_datafile(argv[1]) != 0) {
		printf("Cannot open %s. It is probably not a datafile\n", argv[1]);
		return -1;
	}

	// open patch files even they don't exist now. We may distribute them later
	// without changing the executable
	open_datafile("patch1.dat");
	open_datafile("patch2.dat");
	open_datafile("patch3.dat");
	open_datafile("patch4.dat");

	FILE *f = fopen(argv[2],"rb");
	if (!f) {
		printf("Cannot open %s. %s is probably damaged\n", argv[2], argv[1]);
		close_datafile();
		return -2;
	}

	// open output file, assume success
	FILE *g = fopen("output","wb");

	// copy (eg. decompress) the whole file
	while ((x=fread(buf,1,100,f)) > 0) fwrite(buf,1,x,g);

	// fcloseall is also handled by datafile routines but it does NOT close the datafile file itself
	fcloseall();

	close_datafile();
	return 0;
}
